/* V 0.80
 *  wagon-ESP-OSC
 *  un wagon radio-guide
 *  plateforme ESP8266 ESP-12
 *  moteur courant continu
 *  lecteur rfid
 *  protocole OSC
 *  SNHack gepeto@du-libre.org
 *  Codes sous licences GPLV3
 */

/* projet LOCO-DOM
 *  Arduino 1.6.5-rc5 , esp 2.0.0 en json
 *  lib esp8266-OSC, EspSoftSerial
 *
 *  IP du reseau 192.168.0.x/24
 *  les loco sont de x= 81 a 91
 *  ports 9081
 * Connexions ESP-12 BBL-298
 * |-                |   ESP-12   |          |        -|
   |-                |      RST   |       TXD|        -|
   |LDR              | ADC        |       RXD|       - |
   |-                |CH_P        |    GPIO4 |  1 RFID |
   |4 BBL            |   GPIO16   |    GPIO5 |        -|
   |3 BBL            |   GPIO14   |    GPIO0 |        -|
   |led bleu2 BBL-298|   GPIO12   |    GPIO2 |        -|
   |led verte        |   GPIO13   |   GPIO15 |led rouge|
   |-                |   VCC 3V   |       GND|        -|
 * Avec NodeCu
 *  2   D4  GPIO 02
 *  3   D5  GPIO 14
 *  4   D6  GPIO 12
 * RFID TX
 *   D7  GPIO 13
 */
// WIFI
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <Ticker.h> // gestion des timer
//MDNSResponder mdns;
// OSC
//#include <OSCBundle.h>
#include <OSCMessage.h>
#include <OSCBoards.h>
//port numbers for OSC
#define TAILLE_PUCE 13
#define MONIT true   // debug serie
bool MONIWIFI = true ;
bool zouflag = false; // trace on/off au depart
const float Version_prog = 0.80 ;
const unsigned int inPort = 9081;
//destination IP pour la trace OSC
IPAddress MonitIP(192, 168, 0, 99); // IP et port du moniteur
const unsigned int MonitPort = 9998; // suivi normal
//IPAddress DebugIP(192, 168, 0, 123); // IP et port de debug
IPAddress DebugIP(192, 168, 0, 123); // IP et port de debug
const unsigned int DebugPort = 9999;
WiFiUDP udpin;
WiFiUDP udpout;
#include <SoftwareSerial.h>
const int ENTREERFID = 13 ; //NodeCU D7
SoftwareSerial rfid(ENTREERFID, -1, false, 64);
Ticker zoutrace; // OSC envoi position
//Ticker init_rfid; // init port rfid
Ticker ticker_batterie; // verif tension
#include <ArduinoJson.h>
#include "FS.h"
// serial

const char* ssid     = "LOCOMO";
const char* password = "0123456789";
char* nomhost  = "LOCO-XX"; // le nom iendra de l'ip
char* nomloco = "LOCO-XX"; // debut du nom de la loco
int noloco = 2; // no de la loco
char* OSCVar = "/LOCO-XX";

// DHCP donc pas besoin
//IP
//IPAddress (192,168,IPC,IPD);
int IPC = 0;
int IPD = 81;

//Brochage
// Driver moteur - NodeCU
const int enA = 2;  //nodeCU D4
const int in1 = 12; //nodeCU D6
const int in2 = 14; //nodeCU D5

// Olimex ESP8266-DEV
// lecteur RFID
//const int ENTREERFID = 2 ;
//const int enA = 14;
//const int in1 = 13;
//const int in2 = 12;

// ESP8266 platine ESP-12
// lecteur RFID
//const int ENTREERFID = 2 ; //ESP12
//const int enA = 12;
//const int in1 = 14;
//const int in2 = 16;

const int NBR_TABLOTPS = 6;
const int nbr_max_de_puce = 20;
int Vbatterie = 0; // mesure de la tension batterie
int vitesse_mini = 199; // vaincre les frotements
int vitesse_actuelle = 0 ; // vitesse actuelle
int vitesse_temp = 0;
const int vitesse_correction = 0; // correction sur vitesse calcullee ??
int sens = 1;
uint32_t temps_boucle_total = 14000 ; // en milli seconde
uint32_t temps_arrivee_absolu_ms = 0;
uint32_t temps_a_faire_relatif_ms = 0;
uint32_t temps_au_depart_absolu_ms = 0;
uint32_t temps_au_premier_depart_absolu_ms = 0;
uint32_t temps_inter_relatif_ms = 0;
uint32_t temps_inter_relatif_ms_init = 0;
uint32_t temps_course = 0; //temps donne par le tableau
uint32_t temps_restant_relatif_ms = 0; //temps reel restant a faire
uint32_t temps_calcule_relatif_ms = 0;
uint32_t temps_tot_puce = 0;
uint32_t temps_fin_pause_absolu_ms = 0 ;
uint32_t temps_reste_apres_pause = 0 ;
int tablo_vitesse = 0;
int rampe_mini = 20; // >0 AV <0 ARR
int rampe = 0;

unsigned char val = 0x00;
bool lectureok = true;
int nbr_de_puce = 20;
int no_puce_actuelle = 0;
int puce_a_trouver = 0;
int puce_derniere_lue = 0;
int puce_dinit = 0 ;
bool flashraztab = false;
// tableau des puces rfid 20x12
char TableauPuces[nbr_max_de_puce + 1][TAILLE_PUCE + 1] = {
  "000000000000", // puce 0 inexistante on commence a 1 pour json
  "000000000000", // 1
  "000000000000", // 2
  "000000000000", // 3
  "000000000000", // 4
  "000000000000", // 5
  "000000000000", // 6
  "000000000000", // 7
  "000000000000", // 8
  "000000000000", // 9
  "000000000000", // 10
  "000000000000", // 11
  "000000000000", // 12
  "000000000000", // 13
  "000000000000", // 14
  "000000000000", // 15
  "000000000000", // 16
  "000000000000", // 17
  "000000000000", // 18
  "000000000000", // 19
  "000000000000" // 20
};

uint32_t TableauTemps[nbr_max_de_puce + 1][NBR_TABLOTPS + 1]; // temps entre 2 puce, 3 vitesses
// 0 = temps total de la boucle a differente vitesse
// 1 = temps entre puce max et la 1
// 2 = tps entre 1 et 2
// 3 = tps entre 2 et 3
// etc ...
// idx 1=> vit avant, 2=> vit arr avec 10000 ( le tableau est

int commande = 0; // no de la commande en cours

char tag[TAILLE_PUCE + 1] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; // c est du decimal !!
char buf0[TAILLE_PUCE + 1] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
char tag2[TAILLE_PUCE + 1] = {48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 0, 0};
char tagbis[TAILLE_PUCE + 1] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
char tagavant[TAILLE_PUCE + 1] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
char taglu1[TAILLE_PUCE + 1] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
char tagdebut[7] = {'0', '1', '0', '3', 'F', 'A', '1' }; //  0103FA1
char taglu3[TAILLE_PUCE + 1] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

bool MonitMsg(char debugbla[], int debugint) {
  sprintf(OSCVar, "/LOCO-%d/%s", noloco, debugbla);
  if (MONIT) {
    Serial.println("");
    Serial.println(OSCVar);
  }
  OSCMessage envoi(OSCVar);
  //envoi.add(debugbla);
  envoi.add(debugint);

  udpout.beginPacket(MonitIP, MonitPort);
  envoi.send(udpout);
  udpout.endPacket();

  udpout.beginPacket(DebugIP, DebugPort);
  envoi.send(udpout);
  udpout.endPacket();
  envoi.empty();
}
void jesuisla() { // envoie OSC /msg if position vitesse
  OSCMessage zouzou(OSCVar);
  zouzou.add("cmd puce vits pause tps ");
  zouzou.add((int32_t)commande); // commande en cours
  zouzou.add((int32_t)no_puce_actuelle);
  zouzou.add((int32_t)vitesse_actuelle);
  if (temps_fin_pause_absolu_ms > 0)  zouzou.add((int32_t)(temps_fin_pause_absolu_ms - (uint32_t)millis() ) / 1000);
  else zouzou.add(0);
  zouzou.add((int32_t)(millis() / 1000));
  udpout.beginPacket(MonitIP, MonitPort);
  zouzou.send(udpout);
  udpout.endPacket();
  if (MONIWIFI) {
    udpout.beginPacket(DebugIP, DebugPort);
    zouzou.send(udpout);
    udpout.endPacket();
  }
  zouzou.empty(); // free space occupied by
}
void Verif_Tension() { // lit ADC pour voir si tension entre 9 et 12.5
  Vbatterie = analogRead(A0);
  delay(50);
  MonitMsg("VBATTERIE", Vbatterie);
  if ( Vbatterie = analogRead(A0) < 300  ) MonitMsg("VBATTERIE/NONBRANCHEE", Vbatterie);
  if (Vbatterie < 600 && Vbatterie >= 300) { // a voir ..
    //Vitesse_moteur(0, 0);
    MonitMsg("VBATTERIE/ERR/SEDECHARGE", Vbatterie);
  }
}
int Lit_Serie() {
  int i = 0;
  //strncpy(taglu1, buf0,  TAILLE_PUCE + 1);
  if (rfid.available() > 0) { // truc dispo
    strncpy( taglu1, buf0, TAILLE_PUCE );
    val = rfid.read();
    if (val  == 2) { // debut sur start
      i = 0;
      while (i <= TAILLE_PUCE) {
        if ( rfid.available() > 0) {
          val = rfid.read();
          //Serial.print(i);
          //Serial.print(" ");
          //Serial.println(val, HEX );
          if ((val == 2) || (val == 3)) {  // sort si start/stop
            break;
          }
          taglu1[i] = (char)val;
          i++;
        }
      }
      if (i == (TAILLE_PUCE - 1 ) ) { // bonne taille
        taglu1[TAILLE_PUCE] = '\0'; // on ferme ici
        MonitMsg(taglu1, puce_dinit);
        if (MONIT) {
          Serial.print("tag: ");
          Serial.println(taglu1);
        }
        return (0);
      }
    }
  }
  return (1);
}
int Lit_Verifi() {
  while (Lit_Serie() != 0) delay(20);
  //if (strncmp(tag, tagdebut, 7) == 0 && ( (uint32_t)millis() - temps_inter_relatif_ms_init > 4000 )  ) {
  if ( (uint32_t)millis() - temps_inter_relatif_ms_init > 4000 ) { // ne pas renvoyer avant 4s
    //if(MONIT) Serial.println("ok");
    temps_inter_relatif_ms_init = (uint32_t)millis();
    return (0);
  }
  return (1);
}

int Lit_rfid() {
  // mise en forme de la lecture rfid
  //retourne le no_puce
  //Serial.println("attente rfid");
  int i = 0;
  if (rfid.available() > 0) { // truc dispo
    strncpy( tag, buf0, TAILLE_PUCE );
    val = rfid.read();
    if (val  == 2) { // debut sur start
      i = 0;
      while (i <= TAILLE_PUCE) {
        if ( rfid.available() > 0) {
          val = rfid.read();
          //Serial.println(val, HEX );
          if ((val == 2) || (val == 3)) {  // sort si start/stop
            break;
          }
          tag[i] = char(val);
          i++;
        }
      }
      if (i == (TAILLE_PUCE - 1 ) ) { // bonne taille
        tag[TAILLE_PUCE] = '\0'; // Null on ferme la chaine
        if (MONIT) Serial.print(tag);
        for (i = 1; i <= nbr_de_puce; i++) {
          if (strncmp(tag, TableauPuces[i], TAILLE_PUCE) == 0) {
            puce_derniere_lue =  i;
            if (MONIT) Serial.print(" lit rfid ");
            if (MONIT) Serial.println(i);
            MonitMsg("LITPUCE", puce_derniere_lue);
            return (0);
          }
        }
        MonitMsg("PUCEINCONNUE", 999);
        MonitMsg(tag, 999);
        return (99);
      }
    }
  }
  return (1);
}


bool MonitOSC(char debugbla[], int debugint) {
  OSCMessage envoi(debugbla);
  envoi.add(debugint);

  udpout.beginPacket(MonitIP, MonitPort);
  envoi.send(udpout);
  udpout.endPacket();

  udpout.beginPacket(DebugIP, DebugPort);
  envoi.send(udpout);
  udpout.endPacket();
  envoi.empty();
}
int Vitesse_moteur(int moteur, int accel) {
  int i = 0;
  if (moteur == 0 && accel == 0) { //arret brutale
    analogWrite(enA, 0);
    vitesse_actuelle = 0;
    sens = 1;
    return (0);
  }
  moteur = abs(moteur);
  if (moteur > 1024) // filtre le max
    moteur = 1024;
  if (moteur < vitesse_mini && moteur > 0) {
    moteur = vitesse_mini;
    MonitMsg("MOTEUR/VITESSE_MINI", vitesse_mini);
  }
  MonitMsg("MOTEUR/VITESSE", moteur);
  if (MONIT) {
    Serial.print("vitesse ");
    Serial.print(moteur);
    Serial.print(" acel ");
    Serial.println(accel);
  }
  if ( accel < 0 ) {
    sens = -1;
    moteur = -moteur; // ARRIERE
  } else {
    sens = 1;
  }
  accel = abs(accel);
  if ( accel > 50 || accel < rampe_mini ) accel = rampe_mini;
  // en dessous de 20 ca plante !!
  // sinon on garde accel donne
  if (vitesse_actuelle > moteur) {
    for (i = vitesse_actuelle; i >= moteur; i = i - 20) {
      if ( i >= 0 ) {
        //Avant;
        digitalWrite(in1, LOW);
        digitalWrite(in2, HIGH);
      } else {
        //Arriere;
        digitalWrite(in1, HIGH);
        digitalWrite(in2, LOW);
      }
      analogWrite(enA, abs(i));
      delay(accel); // rampe
      //if (MONIT) Serial.println(i);
    }
  } else {
    for ( i = vitesse_actuelle; i <= moteur; i = i + 20) {
      if ( i >= 0 ) {
        //Avant;
        digitalWrite(in1, LOW);
        digitalWrite(in2, HIGH);
      } else {
        //Arriere;
        digitalWrite(in1, HIGH);
        digitalWrite(in2, LOW);
      }
      analogWrite(enA, abs(i));
      delay(accel); // rampe
      //if (MONIT) Serial.println(i);
    }
  }
  vitesse_actuelle = moteur;
  //analogWrite(enA, moteur);
  return (0);
}
// COMMANDES
void ArretMoteur(OSCMessage & msg) {
  commande = 0;
  puce_dinit = 0;
  Serial.println("ArretMoteur /stop");
  MonitMsg("STOP", 0);
  analogWrite(enA, 0);
  vitesse_actuelle = 0;
  temps_fin_pause_absolu_ms = 0;
  //puce_derniere_lue = 0;
}
void MoteurControl(OSCMessage & msg) {
  // met le moteur Ã  la vitesse reÃ§ue, accel
  //commande = 1; ne change pas l'ordre en cours
  Serial.println("/moteur");
  Vitesse_moteur(msg.getInt(0), msg.getInt(1));
}
void Raztablo() {
  // RAZ du tableau
  nbr_de_puce = nbr_max_de_puce;
  if (MONIT) {
    Serial.println("raztaleau");
    Serial.println(nbr_de_puce);
  }
  for (int i = 0; i <= nbr_de_puce ; i++) {
    strncpy (TableauPuces[i], tag2, TAILLE_PUCE );
  }
  MonitMsg("INIT/RAZTABLEAUX", nbr_max_de_puce);
  //if (MONIT) Serial.println("formatage flash");
  //SPIFFS.format();
  //SPIFFS.begin();
  //if (MONIT) Serial.println("formatage flash ok ");

  //InitVitesseDefaut();
  flashraztab = true;
  FlashTablePuces();
  flashraztab = true;
  FlashTab0();
  flashraztab = true;
  FlashTab1();
  flashraztab = false;
  FlashTab2();
  flashraztab = false;
  FlashTab3();
  flashraztab = false;
}
//
// Récupere la config de la flash
// des fichiers config.json et temps.json
//
int Reprendre_config() {
  if (!SPIFFS.begin()) {
    if (MONIT) Serial.println("Failed to mount file system");
  }
  File configFile = SPIFFS.open("/config.json", "r");
  if (!configFile) {
    if (MONIT) Serial.println("pb de lecture de /config.json");
    nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASHLUE/ERR/LECTURE", nbr_de_puce);
  } else {
    size_t size = configFile.size();
    if (size > 1024) {
      if (MONIT) Serial.println("Reprend config Config file size is too large");
      return 3;
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);

    // We don't use String here because ArduinoJson library requires the input
    // buffer to be mutable. If you don't use ArduinoJson, you may as well
    // use configFile.readString instead.
    configFile.readBytes(buf.get(), size);

    StaticJsonBuffer<700> jsonBuffer;
    JsonObject& circuit = jsonBuffer.parseObject(buf.get());
    if (!circuit.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /config.json");
      MonitMsg("FLASHLUE/ERR/LECTURE", nbr_de_puce);
      return (1);
    }
    if (MONIT) {
      Serial.println("");
      circuit.printTo(Serial);
    }
    if ( circuit["noloco"] < 70 || circuit["noloco"] > 98 ) IPD = 81 ; // ne devrait pas arriver
    if ( circuit["nbr_de_puce"] > 3) nbr_de_puce = circuit["nbr_de_puce"];
    else nbr_de_puce = nbr_max_de_puce;
    if (circuit["vitesse_mini"] > 100)  vitesse_mini = circuit["vitesse_mini"];
    circuit["version"] = Version_prog;
    if (MONIT) {
      Serial.println(noloco); // vient du setup ip[3]
      Serial.println(Version_prog);
      Serial.println(nbr_de_puce);
      Serial.println(vitesse_mini);
    }
    //MonitMsg(nomloco, 0);
    //delay(20);
    MonitMsg("FLASHLUE/NBR_PUCE", nbr_de_puce);
    delay(20);
    MonitMsg("FLASHLUE/vitesse_mini", vitesse_mini);
    if (nbr_de_puce > 0) {
      for ( int i = 1; i <= nbr_de_puce; i++) {
        if (strlen(circuit["tablepuces"][i - 1]) > 2) {
          strncpy(TableauPuces[i], circuit["tablepuces"][i - 1], TAILLE_PUCE);
          TableauPuces[i][TAILLE_PUCE] = '\0';
          if (MONIT) Serial.println(TableauPuces[i]);
          delay(20);
        } else {
          if (MONIT) Serial.println("reprend config reinit ");
          MonitMsg("FLASHLUE/ERR/RAZAFAIRE", nbr_de_puce);
          return (1);
        }
      }
    }
  }
  if (MONIT) Serial.println(" ");
  configFile.close();
  InitVitesseDefaut();

  File tempsFile0 = SPIFFS.open("/temps0.json", "r");
  if (!tempsFile0) {
    if (MONIT) Serial.println("pb de lecture de /temps0.json");
    //nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASHLUE/ERR/LECTURE", nbr_de_puce);
    return (1);
  } else {
    size_t size = tempsFile0.size();
    if (size > 1024) {
      if (MONIT) Serial.println("temps0 file size is too large");
      return 3;
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);
    tempsFile0.readBytes(buf.get(), size);
    StaticJsonBuffer<300> json2Buffer0;
    JsonObject& jsontablotps0 = json2Buffer0.parseObject(buf.get());
    if (MONIT) jsontablotps0.printTo(Serial);
    if (!jsontablotps0.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /temps0.json");
      MonitMsg("FLASHLUE/ERR/LECTURE", nbr_de_puce);
      return (1);
    }
    if (nbr_de_puce > 0) {
      for ( int i = 0; i <= NBR_TABLOTPS; i++) {
        TableauTemps[i][0] = jsontablotps0["tablotot"][i];
        if (MONIWIFI) MonitMsg("tablotot", (int) jsontablotps0["tablotot"][i]);
      }
    }
    tempsFile0.close();
    if (MONIT) Serial.println("");
  }
  File tempsFile1 = SPIFFS.open("/temps1.json", "r");
  if (!tempsFile1) {
    if (MONIT) Serial.println("pb de lecture de /temps1.json");
    //nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASHLUE/ERR/LECTURE", nbr_de_puce);
    return (1);
  } else {
    size_t size = tempsFile1.size();
    if (size > 1024) {
      if (MONIT) Serial.println("temps1 file size is too large");
      return 3;
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);
    tempsFile1.readBytes(buf.get(), size);
    StaticJsonBuffer<600> json2Buffer1;
    JsonObject& jsontablotps1 = json2Buffer1.parseObject(buf.get());
    if (MONIT) jsontablotps1.printTo(Serial);
    if (!jsontablotps1.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /temps1.json");
      MonitMsg("FLASHLUE/ERR/LECTURE", nbr_de_puce);
      return (1);
    }
    if (nbr_de_puce > 0) {
      for ( int i = 1; i <= nbr_de_puce; i++) {
        TableauTemps[i][1] = jsontablotps1["tablo1"][i];
        if (MONIWIFI) MonitMsg("tablo1", (int) jsontablotps1["tablo1"][i]);
        delay(20);
      }
      for ( int i = 1; i <= nbr_de_puce; i++) {
        TableauTemps[i][2] = jsontablotps1["tablo2"][i];
        if (MONIWIFI) MonitMsg("tablo2", (int) jsontablotps1["tablo2"][i]);
        delay(20);
      }
    }
    tempsFile1.close();
    if (MONIT) Serial.println("");
  }
  File tempsFile2 = SPIFFS.open("/temps2.json", "r");
  if (!tempsFile2) {
    if (MONIT) Serial.println("pb de lecture de /temps2.json");
    //nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASHLUE/ERR/LECTURE", nbr_de_puce);
    return (1);
  } else {
    size_t size = tempsFile2.size();
    if (size > 1024) {
      if (MONIT) Serial.println("temps2 file size is too large");
      return 3;
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);
    tempsFile2.readBytes(buf.get(), size);
    StaticJsonBuffer<600> json2Buffer2;
    JsonObject& jsontablotps2 = json2Buffer2.parseObject(buf.get());
    if (MONIT) jsontablotps2.printTo(Serial);
    if (!jsontablotps2.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /temps2.json");
      MonitMsg("FLASHLUE/ERR/LECTURE", nbr_de_puce);
      return (1);
    }
    if (nbr_de_puce > 0) {
      for ( int i = 1; i <= nbr_de_puce; i++) {
        TableauTemps[i][3] = jsontablotps2["tablo3"][i];
        if (MONIWIFI) MonitMsg("tablo3", (int) jsontablotps2["tablo3"][i]);
        delay(20);
      }
      for ( int i = 1; i <= nbr_de_puce; i++) {
        TableauTemps[i][4] = jsontablotps2["tablo4"][i];
        if (MONIWIFI) MonitMsg("tablo4", (int) jsontablotps2["tablo4"][i]);
        delay(20);
      }
    }
    tempsFile2.close();
    if (MONIT) Serial.println("");
  }
  File tempsFile3 = SPIFFS.open("/temps3.json", "r");
  if (!tempsFile3) {
    if (MONIT) Serial.println("pb de lecture de /temps3.json");
    //nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASHLUE/ERR/LECTURE", nbr_de_puce);
    return (1);
  } else {
    size_t size = tempsFile3.size();
    if (size > 1024) {
      if (MONIT) Serial.println("temps3 file size is too large");
      return 3;
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);
    tempsFile3.readBytes(buf.get(), size);
    StaticJsonBuffer<600> json2Buffer3;
    JsonObject& jsontablotps3 = json2Buffer3.parseObject(buf.get());
    if (MONIT) jsontablotps3.printTo(Serial);
    if (!jsontablotps3.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /temps3.json");
      MonitMsg("FLASHLUE/ERR/LECTURE", nbr_de_puce);
      return (1);
    }
    if (nbr_de_puce > 0) {
      for ( int i = 1; i <= nbr_de_puce; i++) {
        TableauTemps[i][5] = jsontablotps3["tablo5"][i];
        if (MONIWIFI) MonitMsg("tablo5", (int) jsontablotps3["tablo5"][i]);
        delay(20);
      }
      for ( int i = 1; i <= nbr_de_puce; i++) {
        TableauTemps[i][6] = jsontablotps3["tablo6"][i];
        if (MONIWIFI) MonitMsg("tablo6", (int) jsontablotps3["tablo6"][i]);
        delay(20);
      }
    }
    tempsFile3.close();
    if (MONIT) Serial.println("");
  }


  if (MONIT) Serial.println("");
  return (0);
}
void DonneFlash(OSCMessage & msg) {
  LitFlash();
}
int LitFlash() {
  // commande = 13; transparente
  File configFile = SPIFFS.open("/config.json", "r");
  if (!configFile) {
    if (MONIT) Serial.println("pb de lecture de /config.json");
    return (2);
  } else {
    size_t size = configFile.size();
    if (size > 1024) {
      if (MONIT) Serial.println("Donne flash Config file size is too large");
      return (2);
    }
    std::unique_ptr<char[]> buf2(new char[size]);
    configFile.readBytes(buf2.get(), size);
    StaticJsonBuffer<700> jsonBuffer;
    JsonObject& circuit = jsonBuffer.parseObject(buf2.get());
    if (!circuit.success()) {
      if (MONIT) Serial.println("donneflash parse pb de lecture de /config.json");
      return (2);
    } else {
      //MonitMsg(nomloco, 0);
      if (MONIT) {
        Serial.println("");
        circuit.printTo(Serial);
      }
      MonitMsg("FLASH/DONNE/NOLOCO", circuit["noloco"]);
      delay(20);
      circuit["version"] = Version_prog;
      MonitMsg("FLASH/DONNE/version", circuit["version"]);
      delay(20);
      MonitMsg("FLASH/DONNE/nbr_de_puce", circuit["nbr_de_puce"]);
      delay(20);
      MonitMsg("FLASH/DONNE/vitesse_mini", circuit["vitesse_mini"]);
      if (MONIT) Serial.println("");
      for (int i = 1; i <= nbr_de_puce; i++) {
        char buffpuce[TAILLE_PUCE + 1];
        strncpy(buffpuce, circuit["tablepuces"][i - 1], TAILLE_PUCE);
        buffpuce[TAILLE_PUCE] = '\0';
        MonitMsg(buffpuce, i);
        delay(30);
      }
      configFile.close();
    }
  }

  File tempsFile0 = SPIFFS.open("/temps0.json", "r");
  if (!tempsFile0) {
    if (MONIT) Serial.println("pb de lecture de /temps0.json");
    //nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASHDONNE/ERR/LECTURE", nbr_de_puce);
    return (2);
  } else {
    size_t size = tempsFile0.size();
    if (size > 1024) {
      if (MONIT) Serial.println("temps0 file size is too large");
      return (2);
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);
    tempsFile0.readBytes(buf.get(), size);
    StaticJsonBuffer<300> json2Buffer0;
    JsonObject& jsontablotps0 = json2Buffer0.parseObject(buf.get());
    if (!jsontablotps0.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /temps0.json");
      MonitMsg("FLASHDONNE/ERR/LECTURE", nbr_de_puce);
      return (2);
    } else {
      if (MONIT) {
        Serial.println(" ");
        jsontablotps0.printTo(Serial);
        Serial.println("");
        MonitMsg("FLASHDONNE/TPSTOTAV", jsontablotps0["tablotot"][1]);
        delay(30);
        MonitMsg("FLASHDONNE/TPSTOTARR", jsontablotps0["tablotot"][2]);
      }
    }
    tempsFile0.close();
  }

  File tempsFile1 = SPIFFS.open("/temps1.json", "r");
  if (!tempsFile1) {
    if (MONIT) Serial.println("pb de lecture de /temps1.json");
    //nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASHDONNE/ERR/LECTURE", nbr_de_puce);
    return (2);
  } else {
    size_t size = tempsFile1.size();
    if (size > 1024) {
      if (MONIT) Serial.println("temps1 file size is too large");
      return (2);
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);
    tempsFile1.readBytes(buf.get(), size);
    StaticJsonBuffer<600> json2Buffer1;
    JsonObject& jsontablotps1 = json2Buffer1.parseObject(buf.get());
    if (!jsontablotps1.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /temps1.json");
      MonitMsg("FLASH/ERR/LECTURE", nbr_de_puce);
      return (2);
    } else {
      if (MONIT) {
        Serial.println(" ");
        jsontablotps1.printTo(Serial);
        Serial.println("");
      }
    }
    tempsFile1.close();
  }

  File tempsFile2 = SPIFFS.open("/temps2.json", "r");
  if (!tempsFile2) {
    if (MONIT) Serial.println("pb de lecture de /temps2.json");
    //nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASHDONNE/ERR/LECTURE", nbr_de_puce);
    return (2);
  } else {
    size_t size = tempsFile2.size();
    if (size > 1024) {
      if (MONIT) Serial.println("temps2 file size is too large");
      return (2);
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);
    tempsFile2.readBytes(buf.get(), size);
    StaticJsonBuffer<600> json2Buffer2;
    JsonObject& jsontablotps2 = json2Buffer2.parseObject(buf.get());
    if (!jsontablotps2.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /temps2.json");
      MonitMsg("FLASH/ERR/LECTURE", nbr_de_puce);
      return (2);
    } else {
      if (MONIT) {
        Serial.println(" ");
        jsontablotps2.printTo(Serial);
        Serial.println("");
      }
    }
    tempsFile2.close();
  }

  File tempsFile3 = SPIFFS.open("/temps3.json", "r");
  if (!tempsFile3) {
    if (MONIT) Serial.println("pb de lecture de /temps3.json");
    //nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASHDONNE/ERR/LECTURE", nbr_de_puce);
    return (2);
  } else {
    size_t size = tempsFile3.size();
    if (size > 1024) {
      if (MONIT) Serial.println("temps3 file size is too large");
      return (2);
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);
    tempsFile3.readBytes(buf.get(), size);
    StaticJsonBuffer<600> json2Buffer3;
    JsonObject& jsontablotps3 = json2Buffer3.parseObject(buf.get());
    if (!jsontablotps3.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /temps3.json");
      MonitMsg("FLASH/ERR/LECTURE", nbr_de_puce);
      return (2);
    } else {
      if (MONIT) {
        Serial.println(" ");
        jsontablotps3.printTo(Serial);
        Serial.println("");
      }
    }
    tempsFile3.close();
  }
}
//
// Sauvegarde des parametres dans la flash
//
int FlashTableauxPuces() {
  FlashTablePuces();
  FlashTab0();
  FlashTab1();
  FlashTab2();
  FlashTab3();
  flashraztab = false;
}
int FlashTablePuces() {
  if (MONIT) Serial.println("commence flash config.json ");
  StaticJsonBuffer<700> jsonBuffer;
  JsonObject& circuit = jsonBuffer.createObject();
  //circuit["nom"] = nomloco;
  circuit["noloco"] = noloco;
  circuit["version"] = Version_prog;
  circuit["nbr_de_puce"] = nbr_de_puce;
  circuit["vitesse_mini"] =  vitesse_mini ;
  JsonArray& tablepuce = circuit.createNestedArray("tablepuces");
  if (flashraztab) strncpy(TableauPuces[0], tag2, TAILLE_PUCE);
  for (int i = 1; i <= nbr_de_puce; i++) {
    if (flashraztab) strncpy(TableauPuces[i], tag2, TAILLE_PUCE);
    tablepuce.add(TableauPuces[i]);
  }
  delay(100);
  File confFile = SPIFFS.open("/config.json", "w");
  if (!confFile) {
    if (MONIT) Serial.println("Failed to open config file for writing");
    MonitMsg("FLASH/ERR/ECRITURE", nbr_de_puce);
    return (3);
  }
  circuit.printTo(confFile);
  delay(100);
  if (MONIT) {
    Serial.println("");
    Serial.println("FLASHconfig.json OK");
    circuit.printTo(Serial);
  }
  confFile.flush();
  delay(100);
  confFile.close();
  MonitMsg("FLASH/PUCE/OK", nbr_de_puce);
  return (0);
}
//tablotot dans temps0
int FlashTab0() {
  if (MONIT) Serial.println(" flash temps0.json ");
  StaticJsonBuffer<300> jsont0Buffer;
  JsonObject& jsontablotps0 = jsont0Buffer.createObject();
  JsonArray& tablotot0 = jsontablotps0.createNestedArray("tablotot");// tableau de temps totale boucle
  if (flashraztab) TableauTemps[0][0] = 0;
  for (int i = 0; i <= NBR_TABLOTPS; i++) {
    if (TableauTemps[i][0] == 0) {
      for (int j = 0; j <= nbr_de_puce; j++) TableauTemps[i][0] += TableauTemps[i][j];
    }
    if (flashraztab) TableauTemps[i][0] = 0;
    tablotot0.add(TableauTemps[i][0]);
  }

  File tempsFile0 = SPIFFS.open("/temps0.json", "w");
  if (!tempsFile0) {
    if (MONIT) Serial.println("Failed to open tempsFile0 file for writing");
    MonitMsg("FLASH/ERR/ECRITURETEMPS", nbr_de_puce);
    return (3);
  }
  jsontablotps0.printTo(tempsFile0);
  tempsFile0.flush();
  delay(100);
  tempsFile0.close();
  if (MONIT) {
    Serial.println(" ");
    jsontablotps0.printTo(Serial);
    Serial.println(" ");
  }
  MonitMsg("FLASH/TPS0/OK", nbr_de_puce);
  return (0);
}
// tablo 1 et 2 dans temps1
int FlashTab1() {
  if (MONIT) Serial.println(" flash temps1.json ");
  StaticJsonBuffer<600> jsont1Buffer;
  JsonObject& jsontablotps1 = jsont1Buffer.createObject();
  JsonArray& tablo1 = jsontablotps1.createNestedArray("tablo1");
  tablo1.add( TableauTemps[0][1]);
  for (int i = 1; i <= nbr_de_puce; i++) {
    if (flashraztab) TableauTemps[i][1] = 0;
    tablo1.add( TableauTemps[i][1]);
  }
  JsonArray& tablo2 = jsontablotps1.createNestedArray("tablo2");
  tablo2.add( TableauTemps[0][2]);
  for (int i = 1; i <= nbr_de_puce; i++) {
    if (flashraztab) TableauTemps[i][2] = 0;
    tablo2.add( TableauTemps[i][2]);
  }
  File tempsFile1 = SPIFFS.open("/temps1.json", "w");
  if (!tempsFile1) {
    if (MONIT) Serial.println("Failed to open tempsFile1 file for writing");
    MonitMsg("FLASH/ERR/ECRITURETEMPS", nbr_de_puce);
    return (3);
  }
  jsontablotps1.printTo(tempsFile1);
  tempsFile1.flush();
  delay(100);
  tempsFile1.close();
  if (MONIT) {
    Serial.println(" ");
    jsontablotps1.printTo(Serial);
    Serial.println(" ");
  }
  MonitMsg("FLASH/TPS1/OK", nbr_de_puce);
  return (0);
}
// tablo 1 et 2 dans temps1
int FlashTab2() {
  if (MONIT) Serial.println(" flash temps2.json ");
  StaticJsonBuffer<600> jsont2Buffer;
  JsonObject& jsontablotps2 = jsont2Buffer.createObject();
  JsonArray& tablo3 = jsontablotps2.createNestedArray("tablo3");
  tablo3.add( TableauTemps[0][3]);
  for (int i = 1; i <= nbr_de_puce; i++) {
    if (flashraztab) TableauTemps[i][3] = 0;
    tablo3.add( TableauTemps[i][3]);
  }
  JsonArray& tablo4 = jsontablotps2.createNestedArray("tablo4");
  tablo4.add( TableauTemps[0][4]);
  for (int i = 1; i <= nbr_de_puce; i++) {
    if (flashraztab) TableauTemps[i][4] = 0;
    tablo4.add( TableauTemps[i][4]);
  }
  File tempsFile2 = SPIFFS.open("/temps2.json", "w");
  if (!tempsFile2) {
    if (MONIT) Serial.println("Failed to open tempsFile2 file for writing");
    MonitMsg("FLASH/ERR/ECRITURETEMPS", nbr_de_puce);
    return (3);
  }
  jsontablotps2.printTo(tempsFile2);
  tempsFile2.flush();
  delay(100);
  tempsFile2.close();
  if (MONIT) {
    Serial.println(" ");
    jsontablotps2.printTo(Serial);
    Serial.println(" ");
  }
  MonitMsg("FLASH/TPS2/OK", nbr_de_puce);
  return (0);
}
// tablo 5 et 6 dans temps3
int FlashTab3() {
  if (MONIT) Serial.println(" flash temps3.json ");
  StaticJsonBuffer<600> jsont3Buffer;
  JsonObject& jsontablotps3 = jsont3Buffer.createObject();
  JsonArray& tablo5 = jsontablotps3.createNestedArray("tablo5");
  tablo5.add( TableauTemps[0][5]);
  for (int i = 1; i <= nbr_de_puce; i++) {
    if (flashraztab) TableauTemps[i][5] = 0;
    tablo5.add( TableauTemps[i][5]);
  }
  JsonArray& tablo6 = jsontablotps3.createNestedArray("tablo6");
  tablo6.add( TableauTemps[0][6]);
  for (int i = 1; i <= nbr_de_puce; i++) {
    if (flashraztab) TableauTemps[i][6] = 0;
    tablo6.add( TableauTemps[i][6]);
  }
  File tempsFile3 = SPIFFS.open("/temps3.json", "w");
  if (!tempsFile3) {
    if (MONIT) Serial.println("Failed to open tempsFile3 file for writing");
    MonitMsg("FLASH/ERR/ECRITURETEMPS", nbr_de_puce);
    return (3);
  }
  jsontablotps3.printTo(tempsFile3);
  tempsFile3.flush();
  delay(100);
  tempsFile3.close();
  if (MONIT) {
    Serial.println(" ");
    jsontablotps3.printTo(Serial);
    Serial.println(" ");
  }
  MonitMsg("FLASH/TPS3/OK", nbr_de_puce);
  return (0);
}
void SauveFlash(OSCMessage & msg) {
  //commande = 8; transparente
  if (nbr_de_puce == 0) nbr_de_puce = msg.getInt(0);
  if (MONIT) Serial.println("sauvegarde config.json ");
  if (FlashTableauxPuces() == 0) {
    if (MONIT) Serial.println("config.json sauvé");
    MonitMsg("FLASH/SAUVEGARDE/OK", nbr_de_puce);
  }
}
void SauveNbrPuce(OSCMessage & msg) {
  if (msg.getInt(0) > 5) {
    nbr_de_puce = msg.getInt(0);
    FlashTablePuces();
  }
}

void SauveIPD(OSCMessage & msg) { // IP entre 80 et 90
  if (msg.getInt(0) > 0) {
    IPD = msg.getInt(0);
    if (IPD > 80 && IPD < 91) {
      Serial.println(IPD);
      Serial.println("flash et reboot");
      MonitMsg("FLASH/OK/REBOOT", IPD);
      FlashTablePuces();
      delay(2000);
      ESP.restart();
    }
  }
}
void SauveVitessemini(OSCMessage & msg) {
  if (msg.getInt(0) > 0) {
    vitesse_mini = msg.getInt(0);
    FlashTablePuces();
  }
}
// entre les puce 1 par 1
void Prepare_Puce(OSCMessage & msg) {
  nbr_de_puce = abs(msg.getInt(0));
  commande = 21;
  MonitMsg("INIT/PUCEPARPUCE", nbr_de_puce);
  if ( abs(msg.getInt(0)) == 100 ) commande = 0 ; //stop?
}
void Valide_Puce(OSCMessage & msg) {
  puce_dinit = abs(msg.getInt(0));
  if (MONIT) Serial.println(puce_dinit);
  commande = 22;
}
void Entree_Puce(OSCMessage & msg) { // puce 1 par 1 recu en OSC /codepuce si 123TAG no_puce
  int length = msg.getDataLength(0);
  if (length == TAILLE_PUCE ) {
    char str[length];
    msg.getString(0, str, length);
    puce_dinit = abs(msg.getInt(1));
    if (MONIT) {
      Serial.println("tag: ");
      Serial.println(str);
      Serial.println("puce: ");
      Serial.println(puce_dinit);
    }
    strncpy(TableauPuces[puce_dinit], str, TAILLE_PUCE);
    FlashTablePuces();
  }
  commande = 0;
}
void Entree_Puce_Temps(OSCMessage & msg) { // /pucetemps iii tablo puce temps_milli
  puce_dinit = abs(msg.getInt(1));
  if (puce_dinit <= nbr_de_puce) {
    tablo_vitesse =  abs(msg.getInt(0));
    if (tablo_vitesse > 0 || tablo_vitesse <= NBR_TABLOTPS) {
      temps_course =  (uint32_t)abs(msg.getInt(2));
      if (temps_course > 0 && temps_course < TableauTemps[tablo_vitesse][0]) { // vitesse moyenne par comparaison
        TableauTemps[puce_dinit][tablo_vitesse] = temps_course;
        MonitMsg("ENTREE/PUCETEMPS", temps_course);
        if (tablo_vitesse == 1  ) FlashTab1();
        if (tablo_vitesse == 2  ) FlashTab2();
        if (tablo_vitesse == 3  ) FlashTab3();
      } else {
        MonitMsg("ENTREE/PUCETEMPS/ERR/TEMPS", temps_course);
        MonitMsg("ENTREE/PUCETEMPS/ERR/TEMPSMAX", TableauTemps[tablo_vitesse][0]);
      }
    } else {
      MonitMsg("ENTREE/PUCETEMPS/ERR/TABLE", tablo_vitesse);
    }
  } else {
    MonitMsg("ENTREE/PUCETEMPS/ERR/NOPUCE", puce_dinit);
  }
  commande = 0;
  puce_dinit = 0;
  temps_course = 0;
}
void Verif_Tableau(OSCMessage & msg) {
  commande = 25;
  MonitMsg("INIT/VERIFTABLEAU", nbr_de_puce);
  puce_dinit = 1;
  Vitesse_moteur(500, 0);
  puce_derniere_lue = 0;
  strncpy (taglu1, buf0, TAILLE_PUCE + 1);
  strncpy (tagavant, buf0, TAILLE_PUCE + 1);
}
// Initialisation tableau des puces
//
void Initialisation_Tableau(OSCMessage & msg) {
  // Placer la loco juste avant la puce qui sera la 1
  // la loco fait un tour complet doucement pour connaitre les puces
  int nbrpuce = 0;
  if (msg.getInt(0) > 0) {
    nbr_de_puce = abs(msg.getInt(0));
    if (nbr_de_puce == 99 ) {
      Raztablo() ;
      commande = 0;
    } else {
      commande = 2;
      zouflag = false;
      zoutrace.detach();
      MonitMsg("TRACEOFF", 1);
      MonitMsg("INIT/DEBUT", nbr_de_puce);
      puce_dinit = 1 ;
      puce_derniere_lue = 0;
      strncpy (taglu1, buf0, TAILLE_PUCE );
      strncpy (tagavant, buf0, TAILLE_PUCE );
      rfid.flush();
      Lit_Serie(); // vider
      Vitesse_moteur(600, 0);
    }
  }
}
void InitVitesseDefaut() {
  TableauTemps[0][0] = 1000;
  TableauTemps[0][1] = 500;
  TableauTemps[0][2] = 10000 + 500;
  TableauTemps[0][3] = 350;
  TableauTemps[0][4] = 10000 + 350;
  TableauTemps[0][5] = 250;
  TableauTemps[0][6] = 10000 + 250;
}
void Initialisation_Vitesse(OSCMessage & msg) {
  // msg 0 = no du tableau  400; sens +/-
  // on demare sur la 1 on a deja le tableau de puce
  // on remplie les tableaux Avant et Arr pour la vitesses (vitesse_actuelle)
  // TableauTemps[nbr_max_de_puce][3] la vitesses est dans puce 0
  commande = 50;
  zouflag = false;
  zoutrace.detach();
  MonitMsg("TRACEOFF", 1);
  tablo_vitesse =  abs(msg.getInt(0));
  if (tablo_vitesse >= 90) { //init des tableaux
    InitVitesseDefaut;
    commande = 49;
    flashraztab = true;
    if (tablo_vitesse == 90 || tablo_vitesse == 99  ) FlashTab0(); // init les tableau temps a 0
    if (tablo_vitesse == 91 || tablo_vitesse == 99  ) FlashTab1();
    if (tablo_vitesse == 92 || tablo_vitesse == 99  ) FlashTab2();
    if (tablo_vitesse == 93 || tablo_vitesse == 99  ) FlashTab3();
    flashraztab = false;
    MonitMsg("INIT/TABLEAUX", tablo_vitesse);
    commande = 0;
  } else {
    if (tablo_vitesse >= 1 && tablo_vitesse <= NBR_TABLOTPS) {
      if (TableauTemps[0][tablo_vitesse] > 10000) { // ARR
        sens = -1;
        puce_dinit = nbr_de_puce ;
        puce_derniere_lue = 0;
        Vitesse_moteur((int)(10000 - TableauTemps[0][tablo_vitesse]), sens); // vitesse vien de l'init des variables
        MonitMsg("INIT/TABLEAUTEMPS", (int)(10000 - TableauTemps[0][tablo_vitesse] ) );
      } else { // AVANT
        sens = 0;
        puce_dinit = 2 ;
        puce_derniere_lue = 0;
        Vitesse_moteur((int)(TableauTemps[0][tablo_vitesse]), sens); // vitesse vien de l'init des variables
        MonitMsg("INIT/TABLEAUTEMPS", TableauTemps[0][tablo_vitesse] );
      }
      commande = tablo_vitesse + 50;
      temps_boucle_total = (uint32_t)millis();
      temps_inter_relatif_ms_init = (uint32_t)millis();
      delay(20);
      MonitMsg("INIT/TABLEAUTEMPSSENS", sens );
    }
  }
}
//
// GOTO iii puce temps acceleration
//
void Rendezvous(OSCMessage & msg) {
  // /goto iii puce temps rampe : se rendre a la puce xx en tant de seconde
  Vitesse_moteur(0, 0);
  commande = 3;
  temps_fin_pause_absolu_ms = 0;
  int distance = 0;
  float vitesse = 0;
  int puce = 0;
  int err = 0;
  uint32_t temps_course = 0;
  puce_a_trouver = msg.getInt(0);
  if (puce_a_trouver == 0 || puce_a_trouver > nbr_de_puce) {
    MonitMsg("GOTO/ERR/PASDEPUCE", puce_a_trouver);
    err = 1;
  } else {
    temps_a_faire_relatif_ms = (uint32_t)msg.getInt(1) * 1000  ; // entree en seconde
    //temps_boucle_total = TableauTemps[1][0]; // meilleurs temps possible?
    rampe = msg.getInt(2); // si <0 alors marche arriere
    if (temps_a_faire_relatif_ms < 2000) {
      MonitMsg("GOTO/ERR/TEMPSTROPCOURT", temps_arrivee_absolu_ms);
      temps_arrivee_absolu_ms = 2000;
      err = 2;
    }
    if ( rampe < 0 ) {
      sens = -1;
      if (temps_a_faire_relatif_ms > (20 * TableauTemps[2][0] )) {
        MonitMsg("GOTO/ERR/TEMPSTROPLONG", temps_arrivee_absolu_ms);
        err = 3;
      }
    } else {
      sens = 1;
      if (temps_a_faire_relatif_ms > (20 * TableauTemps[1][0] )) {
        MonitMsg("GOTO/ERR/TEMPSTROPLONG", temps_arrivee_absolu_ms);
        err = 4;
      }
    }
    if (err == 0 ) {
      if (puce_derniere_lue == 0  ||  puce_derniere_lue > 90  ) { // on ne connait pas la puce depart
        if (MONIT) Serial.print("/rdv cherche premiere puce ");
        if (MONIT) Serial.println(puce_derniere_lue);
        MonitMsg("GOTO/ATTENTE_PUCE", 390);
        Vitesse_moteur(800, 0);
        while (Lit_rfid() != 0) delay(200); // on cherche la prochaine, renseigne puce_derniere_lue
        no_puce_actuelle = puce_derniere_lue;
      }
      MonitMsg("GOTO/PUCE_DEPART", no_puce_actuelle );
      if (MONIT) {
        Serial.print("/rdv de ");
        Serial.print(puce_derniere_lue);
        Serial.print(" a trouver ");
        Serial.println(puce_a_trouver);
      }
      temps_au_premier_depart_absolu_ms = (uint32_t)millis();
      temps_au_depart_absolu_ms = (uint32_t)millis();
      temps_arrivee_absolu_ms = temps_au_depart_absolu_ms + temps_a_faire_relatif_ms;
      temps_calcule_relatif_ms = 0;
      vitesse_temp = CalculVitesse(1); // recalcule avec tableau 1 AVV

      // recalcule pour plus de precision
      temps_au_depart_absolu_ms = (uint32_t)millis();
      temps_arrivee_absolu_ms = temps_au_depart_absolu_ms + temps_a_faire_relatif_ms;
      temps_calcule_relatif_ms = 0;
      if (sens == 1)  {
        if (vitesse_temp > 450) vitesse_temp = CalculVitesse(1);
        else if (vitesse_temp < 300) vitesse_temp = CalculVitesse(5);
        else vitesse_temp = CalculVitesse(3);
      } else {
        if (vitesse_temp > 450) vitesse_temp = CalculVitesse(2);
        else if (vitesse_temp < 300) vitesse_temp = CalculVitesse(6);
        else vitesse_temp = CalculVitesse(4);
      }
      MonitMsg("GOTO/VITESSEDEBUT", vitesse_temp);

      if (vitesse_temp >= 1010) {
        MonitMsg("GOTO/ERR/TEMPS_TROP_COURT", TableauTemps[1][0] );
        vitesse = 1000;
      }
      if (vitesse_temp <= vitesse_mini) { // temps trop long avec vitesse mini
        // calcul avec vitesse moyenne attention si mini > resultat de tableau fait avec une autre vit mini
        temps_fin_pause_absolu_ms = temps_arrivee_absolu_ms - temps_calcule_relatif_ms;

        if (MONIT) {
          Serial.println("pause a: ");
          Serial.println(millis());
          Serial.println("temps_arrivee_absolu_ms: ");
          Serial.println(temps_arrivee_absolu_ms);
          Serial.println("temps_calcule_relatif_ms: ");
          Serial.println(temps_calcule_relatif_ms);
          Serial.println("temps_fin_pause_absolu_ms: ");
          Serial.println(temps_fin_pause_absolu_ms);
        }
        commande = 31;
      } else {
        Vitesse_moteur(vitesse_temp, rampe); // on roule , pendant un certain temps
      }
    }
  }
}
//
int CalculVitesse(int tablo) {
  float vitesse = 0;
  temps_course = 0;
  temps_restant_relatif_ms = temps_arrivee_absolu_ms - (uint32_t)millis() ; //
  if (MONIT) {
    Serial.println(millis());
    Serial.println(temps_arrivee_absolu_ms);
    Serial.println(temps_restant_relatif_ms);
    Serial.println(sens);
  }
  // puce devant plus grande
  if ((puce_a_trouver > puce_derniere_lue) && sens == 1) {
    if (MONIT) Serial.print("tblo ");
    for (int p = puce_derniere_lue + 1 ; p <= puce_a_trouver ; p++) {
      temps_course += TableauTemps[p][tablo];
      if (MONIT) Serial.println(TableauTemps[p][tablo]);
    }
  } else {
    if ((puce_a_trouver < puce_derniere_lue) && sens == 1) {
      // puce devant plus petite et marche avant
      for (int p = puce_derniere_lue; p <= nbr_de_puce; p++) temps_course += TableauTemps[p][tablo];
      for (int p = 1; p <= puce_a_trouver ; p++) temps_course += TableauTemps[p][tablo];
    } else {
      if ((puce_a_trouver > puce_derniere_lue) && sens == -1) { //arriere
        for (int p = puce_derniere_lue - 1; p >= 1; p--) temps_course += TableauTemps[p][tablo];
        for (int p = nbr_de_puce; p >= puce_a_trouver; p--) temps_course += TableauTemps[p][tablo];
      } else {
        if ((puce_a_trouver < puce_derniere_lue) && sens == -1) { //arriere
          for (int p = puce_derniere_lue - 1; p >= puce_a_trouver; p--) temps_course += TableauTemps[p][tablo];
        } else {
          if ((puce_a_trouver == puce_derniere_lue)) { //si meme puce alors un tour complet
            if (MONIT) Serial.println("tour");
            MonitMsg("GOTO/DEJALA", puce_derniere_lue );
            commande = 0;
            return (0);
          }
        }
      }
    }
  }
  MonitMsg("GOTO/TEMPSRESTANT", temps_restant_relatif_ms / 1000);
  delay(20);
  MonitMsg("GOTO/TABLOCOURSE", tablo);
  delay(20);
  MonitMsg("GOTO/TEMPSTTABLOCOURSE", temps_course / 1000);
  temps_calcule_relatif_ms = temps_course ;
  float vitess_tablo = TableauTemps[0][tablo];
  if (vitess_tablo >= 10000) vitess_tablo = vitess_tablo - 10000; // pour ARR
  vitesse =  vitess_tablo * ((float)temps_course / (float)temps_restant_relatif_ms);
  if (vitesse >= 1024) {
    MonitMsg("GOTO/VITESSETROPGRANDE", (int)vitesse);
    vitesse = 1000;
    //commande = 0;
    //return (0);
  }
  if (MONIT) {
    Serial.print("recalculvitesse: ");
    Serial.println(vitess_tablo);
    Serial.print("temps restant: ");
    Serial.println(temps_restant_relatif_ms);
    Serial.print("temps course: ");
    Serial.println(temps_course);
    Serial.print("vitesse: ");
    Serial.println((int)vitesse);
  }
  return ((int)vitesse);
}

//
// / aller iii puce vitesse acceleration

bool Aller(int no_puce, int vitesse, int accel) {
  // aller jusqu'a la puce no_puce a vitesse
  if (MONIT) Serial.print("Aller ");
  if (MONIT) Serial.println(no_puce);
  MonitMsg("ALLER", no_puce);
  puce_a_trouver = no_puce;
  temps_fin_pause_absolu_ms = 0;
  if (puce_a_trouver == 0 || puce_a_trouver > nbr_de_puce) {
    MonitMsg("ALLER/ERR/PASDEPUCE", puce_a_trouver);
  } else {
    temps_au_premier_depart_absolu_ms = (uint32_t)millis();
    temps_au_depart_absolu_ms = (uint32_t)millis();
    temps_tot_puce = temps_au_depart_absolu_ms;
    rampe = accel;
    Vitesse_moteur(vitesse, accel);
    return (true);
  }
  return (false);
}
//
void SeRendre(OSCMessage & msg) {
  // /aller ii puce vitesse : se rendre a la puce xx a n vitesse [acceleration]
  commande = 4;
  Aller((int)msg.getInt(0), (int)msg.getInt(1), (int)msg.getInt(2) );
}

void Ou(OSCMessage & msg) {
  // commande = 9; transparente
  MonitMsg("PUCE/DERNIERELUE", puce_derniere_lue);
}
void Zou(OSCMessage & msg) {
  if (!zouflag) {
    zoutrace.attach(10, jesuisla);
    zouflag = true;
    MonitMsg("TRACEON", 1);
  } else {
    zouflag = false;
    zoutrace.detach();
    MonitMsg("TRACEOFF", 1);
  }
  if (msg.getInt(0) == 1) MONIWIFI = true;
  if (msg.getInt(0) == 0) MONIWIFI = false;
}

void Recup_Tension(OSCMessage & msg) {
  Verif_Tension();
}
void LitPuce(OSCMessage & msg) {
  commande = 6;
  Serial.println("lit");
  //zou.detach();
  //while (Lit_Serie() > 0) delay(20);
}
//
//
void setup()
{

  /// RAZ DE TOUT AU CAS OU
  //SPIFFS.format();

  Serial.begin(115200);
  InitVitesseDefaut();
  // set all the motor control pins to outputs
  pinMode(enA, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  //digitalWrite(in1, LOW);
  //digitalWrite(in2, LOW);
  //digitalWrite(enA, LOW);
  // serial RFID
  rfid.begin(9600); //
  Serial.println(ESP.getChipId(), HEX);
  //setup ethernet part
  Serial.println();
  Serial.print("locomo ");
  Serial.println(Version_prog);

  Serial.print("Connecting to SSID ");
  Serial.println(ssid);
  WiFi.mode(WIFI_STA);
  //WiFi.hostname(nomhost);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  //  DHCP donc pas fixÃ© ici
  //WiFi.config(IPAddress(192, 168, IPC, IPD), IPAddress(192, 168, IPC, IPD), IPAddress(255, 255, 255, 0));
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println(ssid);
  Serial.println("IP address: ");
  IPAddress IPLOCAL = WiFi.localIP();
  IPD = (int)IPLOCAL[3];
  Serial.println(IPLOCAL);
  //Serial.println(WiFi.macAddress);
  if (IPD > 80 && IPD < 99) noloco = abs(IPD - 80);
  else noloco = IPD;
  Serial.println(noloco);
  sprintf(nomloco, "LOCO-%d", noloco);
  sprintf(OSCVar, "/LOCO-%d", noloco);
  Serial.print("hostname: ");
  Serial.println(nomloco);
  WiFi.hostname(nomloco);
  Serial.println(WiFi.hostname());
  Serial.println("Starting UDP");
  udpin.begin(inPort);
  Serial.print("Local port: ");
  Serial.println(udpin.localPort());

  delay(100);
  // envoi le bonjour
  MonitMsg("BONJOUR", (int32_t)ESP.getChipId());
  MonitMsg("version", (int)(Version_prog * 100));
  //recupere le s puce du fichier /puces.buf
  if (Reprendre_config() != 0 ) {
    MonitMsg("SETUP/FLASH/ERR/RAZAFAIRE", nbr_de_puce);
  }
  // test presence test batterie, resistances non présentes ou pb batterie
  //if ( Vbatterie = analogRead(A0) <= 300  ) MonitMsg("VBATTERIE/NONBRANCHEE", Vbatterie);
  //Verif_Tension();

  // verifier toutes les minutes la batterie
  //ticker_batterie.attach(120, Verif_Tension);

  // placer jesuisla en boucle timer 1m
  if ( zouflag == true) {
    zoutrace.attach(60, jesuisla);
    MonitMsg("TRACEON", 1);

  } else {
    MonitMsg("TRACEOFF", 1);
  }
  jesuisla();
  // init_rfid.attach(10, rfid_port_init); ?
  /*
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);
  analogWrite(enA, 500);
  delay(2000);
  analogWrite(enA, 700);
  delay(2000);
  analogWrite(enA, 900);
  */
  //Serial.println("init rfid"); // vider le tuyau !!!
  //rfid.service();
  analogWrite(enA, 0); // stop si pb alim
  rfid.flush();
  rfid.flush();
}
//
void loop()
{
  // Lire la comande et executer le debut
  OSCMessage msgIN;
  int size;
  char puce_char[] = "  ";
  if ( (size = udpin.parsePacket()) > 0)
  {
    while (size--)
      msgIN.fill(udpin.read());

    if (!msgIN.hasError()) {
      // /stop immediat moteur et commande
      msgIN.dispatch("/stop", ArretMoteur);  // commande=0

      // /moteur ii vitesse +/- rampe (av/arr)
      //        rampe  <0 : marche arriere, 0 brutal
      msgIN.dispatch("/moteur", MoteurControl); //  commande=1 n cmd transparente

      // /init fait un tour pour decouvrir les puces, inittableau nbr_de_puce
      // /inittableau i nbr_de_puce 99=RAZ de TOUS les tableaux (vitesses aussi)
      msgIN.dispatch("/inittableau", Initialisation_Tableau);  // commande=2

      // se mettre en boucle lecture puis entrer les puce 1 / 1
      msgIN.dispatch("/puceboucle", Prepare_Puce);  // commande=21 /puceboucle i nbre_de_puce
      msgIN.dispatch("/puceok", Valide_Puce);  // commande=22 /puceok i nopuce
      msgIN.dispatch("/pucecode", Entree_Puce);  // commande=23 flash un tag directement : /pucecode si tag nopuce
      msgIN.dispatch("/pucetemps", Entree_Puce_Temps);  // /pucetemps iii tablo no_puce temp_milli

      // /veriftableau // renvoi si puce pb
      msgIN.dispatch("/veriftableau", Verif_Tableau); // commande=25

      // /init fait un tour pour apprendre les temps de parcours
      msgIN.dispatch("/initvitesse", Initialisation_Vitesse);  // commande=19 /initvitesse i 1-6
      // 1 = vitesse 400
      // 2 = -400
      // 99 = init des tableaux a 0

      // /goto iii puce temps(ms) +/-rampe (av/arr) va Ã  la puce dans le temps donne en s
      msgIN.dispatch("/goto", Rendezvous);      // commande=3

      // /aller iii puce vitesse rampe
      msgIN.dispatch("/aller", SeRendre);       // commande=4

      // /sauvepuces enregistre le tableau dans la flash
      msgIN.dispatch("/sauveflash", SauveFlash); // commande=8
      // /donnepuces renvoi les données de la flash
      msgIN.dispatch("/donneflash", DonneFlash); // commande=13

      // /ou renvoi la derniere puce lu
      msgIN.dispatch("/ou", Ou);                //  commande=9
      // /zou renvoi perdiodiquement des info (toggle) commande = 10
      // /zou i 1 declenche sur IP debug
      msgIN.dispatch("/zou", Zou);

      // /sauveip i IPD change IPD, enregistre la flash et reboot  commande= 14
      msgIN.dispatch("/sauveip", SauveIPD); // commande=14

      // /sauvevitessemini i vitesse_mini enregistre la vitesse_mini
      msgIN.dispatch("/sauvevitessemini", SauveVitessemini); // commande=15

      // /sauvenbrpuce i nbr_de_puce, enregistre
      msgIN.dispatch("/sauvenbrpuce", SauveNbrPuce); // commande=17

      // /vbatterie // renvoi le temoin batterie
      msgIN.dispatch("/batterie", Recup_Tension); // commande=18

      // /lit renvoi le code de la derniere puce lue
      msgIN.dispatch("/lit", LitPuce);          //   commande=6

    }
    udpin.flush();
  }
  // Lire une puce et continuer une commande en cours
  if (commande != 0) {
    if (commande == 21 )  { // boucle lecture init tableau des puces 1 par 1
      if (Lit_Serie() == 0 ) {
        if (MONIT) {
          Serial.println(taglu1);
        }
      }
    }
    if (commande == 6) {
      int c = 0;
      while (Lit_Serie() > 0) {
        if (c > 100) break;
        c += 1;
        delay(20);
      }
    }

    if (commande == 25 )  { // verif correxpondance tableau et puce
      if (Lit_Serie() == 0 ) {
        if (puce_dinit > nbr_de_puce) {
          Vitesse_moteur(0, 0);
          commande = 0;
          puce_dinit = 0;
          MonitMsg("INIT/VERIFTABLEAU/FIN", nbr_de_puce);
        }
        if (MONIT) {
          Serial.println(taglu1);
        }
        if ( strncmp(taglu1, tagavant, TAILLE_PUCE) != 0  ) {
          if ( strncmp(taglu1, TableauPuces[puce_dinit], TAILLE_PUCE) != 0 ) MonitMsg("INITVERIF/ERR/PUCEDIFF", puce_dinit);
          else  MonitMsg("INITVERIF/PUCEOK", puce_dinit);
          puce_dinit += 1;
          strncpy (tagavant, taglu1, TAILLE_PUCE);
        }
        delay(20);
      }
    }

    if (commande == 22) { // Valide puce par son no
      if (MONIT) {
        Serial.print("no ");
        Serial.println(puce_dinit);
      }
      strncpy (TableauPuces[puce_dinit], taglu1, TAILLE_PUCE);
      //strncpy (tagavant, tag, TAILLE_PUCE);
      MonitMsg("INIT/PUCEENREGISTREE", puce_dinit - 1);
      if (MONIT) {
        Serial.print(" ok ");
        Serial.println(taglu1);
      }
      if ( puce_dinit == nbr_de_puce   ) {
        MonitMsg("INIT/NBRTOTALDEPUCE/OK", nbr_de_puce);
        FlashTablePuces(); // on a toutes les les puces
        commande = 0;
      } else {
        puce_dinit = 0;
        commande = 21; // on continu a lire
      }
    }
    if (commande == 2 )  { // init tableau des puces
      if (Lit_Serie() == 0 ) {
        if (MONIT) {
          Serial.print("av ");
          Serial.println(tagavant);
          Serial.print("attend ");
          Serial.println(puce_dinit);
        }
        // premiere puce naz du fait de la mise en route on la reecrira a la fin systematiquement

        if ( strncmp (taglu1, tagavant, TAILLE_PUCE ) != 0 && puce_dinit <= nbr_de_puce + 1  ) {
          if (puce_dinit == nbr_de_puce + 1) { // on reecrit la premiere puce
            strncpy (TableauPuces[1], taglu1, TAILLE_PUCE);
            strncpy (tagavant, taglu1, TAILLE_PUCE);
            MonitMsg("INIT/PUCE1ENREGISTREE", 1);
            puce_dinit += 1 ;
          } else if (strncmp(taglu1, "0000", 4) != 0) {
            strncpy (TableauPuces[puce_dinit], taglu1, TAILLE_PUCE);
            strncpy (tagavant, taglu1, TAILLE_PUCE);
            MonitMsg("INIT/PUCEENREGISTREE", puce_dinit);
            delay(20);
            MonitMsg(taglu1, puce_dinit);
            puce_dinit += 1 ;
          }

        } else {
          if (puce_dinit > nbr_de_puce + 1) { // on est repassé sur la 1 donc dinit+1
            Vitesse_moteur(0, 0);
            if (nbr_de_puce != puce_dinit - 2) MonitMsg("INIT/TABLEAU/ERR", puce_dinit - 2);
            nbr_de_puce = puce_dinit - 2;
            MonitMsg("INIT/TABLEAU/OK", nbr_de_puce);
            delay(1000);
            FlashTablePuces(); // on a toutes les les puces
            delay(2000);
            FlashTablePuces(); // on a toutes les les puces
            puce_dinit = 0;
            commande = 0; // on passe a la verification ?
          }
        }
      }
    }
    if (commande == 31) { // pause avant depart
      if ((uint32_t)millis() >= temps_fin_pause_absolu_ms  ) {
        int vitesse = 0;
        if (sens == 1)  {
          vitesse = CalculVitesse(1); // approche moyenne
          if (vitesse > 450) vitesse = CalculVitesse(1); // affinage
          else if (vitesse < 300) vitesse = CalculVitesse(5);
          else vitesse = CalculVitesse(3);
        } else {
          vitesse = CalculVitesse(2);
          if (vitesse > 450) vitesse = CalculVitesse(2);
          else if (vitesse < 300) vitesse = CalculVitesse(6);
          else vitesse = CalculVitesse(4);
        }
        Vitesse_moteur(vitesse, rampe);
        if (vitesse > 0) commande = 3 ; // pause terminee on reprend /GOTO
        else commande = 0;
        temps_fin_pause_absolu_ms = 0;
      } else {
        MonitMsg("GOTO/ENPAUSE", (temps_fin_pause_absolu_ms - (uint32_t)millis() ) / 1000 );
        delay(1000);
      }
    }

    // DEBUT INIT VITESSE
    if (commande >= 51 && commande <= (50 + NBR_TABLOTPS)) {
      while (Lit_rfid() != 0) delay(20);

      if (sens >= 0 && lectureok ) { // AVANT

        MonitMsg("INIT/AVANT/PUCELUE", puce_derniere_lue);
        if ( puce_derniere_lue == 1  && puce_dinit > 3 ) { // tour complet , termine ?
          temps_boucle_total = (uint32_t)millis() - temps_boucle_total ; // gaff au temp de lecture
          TableauTemps[1][tablo_vitesse] = (uint32_t)millis() - temps_inter_relatif_ms_init;
          TableauTemps[tablo_vitesse][0] = temps_boucle_total;
          commande = 0; // fin de init
          Vitesse_moteur(0, 0);
          delay(20);
          MonitMsg("INIT/TOURCOMPLET", tablo_vitesse);
          delay(20);
          MonitMsg("INIT/AVANT/TEMPS", TableauTemps[1][tablo_vitesse]);
          delay(20);
          MonitMsg("INIT/AVANT/TEMPSBOUCLETOTAL", temps_boucle_total );
          puce_dinit = 99;
          FlashTab0(); // boucle tot a chaque fois
          if (tablo_vitesse == 1) FlashTab1();
          if (tablo_vitesse == 3) FlashTab2();
          if (tablo_vitesse == 5) FlashTab3();

        }
        if (puce_derniere_lue == puce_dinit && TableauTemps[puce_derniere_lue][tablo_vitesse] == 0 ) {
          TableauTemps[puce_derniere_lue][tablo_vitesse] = (uint32_t)millis() - temps_inter_relatif_ms_init;
          delay(20);
          MonitMsg("INIT/AVANT/TEMPS", TableauTemps[puce_derniere_lue][tablo_vitesse]);
          temps_inter_relatif_ms_init = (uint32_t)millis();
          puce_dinit += 1;
        }
        if (puce_derniere_lue > puce_dinit && puce_dinit > 0 ) { // on a sauté une puce
          MonitMsg("INIT/ERR/AVANT/PUCELUE", puce_derniere_lue);
          MonitMsg("INIT/ERR/AVANT/ATTENTEPUCE", puce_dinit);
          MonitMsg("INIT/ERR/AVANT/DEJA", TableauTemps[0][tablo_vitesse]);
          commande = 0; // fin de init
          Vitesse_moteur(0, 0);
          puce_dinit = 99;
        }
      }
      if (sens < 0 && lectureok ) { // ARR
        // sens <0 ARR
        //MonitMsg("INIT/ARR/ATTENTEPUCE", puce_dinit);
        if ( puce_derniere_lue == 1 && puce_dinit == 1) { // tour complet ?
          temps_boucle_total = (uint32_t)millis() - temps_boucle_total ; // gaff au temp de lecture
          TableauTemps[1][tablo_vitesse] = (uint32_t)millis() - temps_inter_relatif_ms_init;
          TableauTemps[tablo_vitesse][0] = temps_boucle_total;
          delay(20);
          MonitMsg("INIT/ARR/TOURCOMPLET", 1);
          delay(20);
          MonitMsg("INIT/ARR/TEMPS", TableauTemps[1][tablo_vitesse]);
          commande = 0; // fin de init
          Vitesse_moteur(0, 0);
          delay(20);
          MonitMsg("INIT/ARR/TEMPSBOUCLETOTAL", temps_boucle_total );
          FlashTab0(); // boucle tot a chaque fois
          if (tablo_vitesse == 2 ) FlashTab1();
          if (tablo_vitesse == 4 ) FlashTab2();
          if (tablo_vitesse == 6 ) FlashTab3();
          puce_dinit = 99;
        }
        if (puce_derniere_lue == puce_dinit && puce_dinit > 0 ) {
          TableauTemps[puce_derniere_lue][tablo_vitesse] = (uint32_t)millis() - temps_inter_relatif_ms_init;
          delay(20);
          MonitMsg("INIT/ARR/TEMPS", TableauTemps[puce_derniere_lue][tablo_vitesse]);
          temps_inter_relatif_ms_init = (uint32_t)millis();
          puce_dinit -= 1;
        }
        if (puce_derniere_lue < puce_dinit && puce_derniere_lue > 1 ) { // on a sauté une puce
          MonitMsg("INIT/ERR/AVANT/PUCELUE", puce_derniere_lue);
          MonitMsg("INIT/ERR/AVANT/ATTENTEPUCE", puce_dinit);
          MonitMsg("INIT/ERR/AVANT/DEJA", TableauTemps[0][tablo_vitesse]);
          commande = 0; // fin de init
          Vitesse_moteur(0, 0);
          puce_dinit = 99;
        }
      }
      if (lectureok == false) {
        MonitMsg("INIT/ARR/ERR/PUCELUE", puce_derniere_lue);
        commande = 0; // fin de init
        Vitesse_moteur(0, 0);
        puce_dinit = 99;
      }
      delay(20);
    }
    // FIN INIT

    if (commande == 1 ) { // moteur
      Lit_rfid();
    }
    if (commande == 4 || commande == 3) {
      //puce_derniere_lue revient de Lit_rfid
      if (Lit_rfid() == 0) {
        temps_inter_relatif_ms = (uint32_t)millis() - temps_au_depart_absolu_ms ;
        temps_tot_puce += temps_inter_relatif_ms;
        if ( puce_derniere_lue == puce_a_trouver ) {
          //stopmoteur
          Vitesse_moteur(0, 0); //rampe a 0
          if (MONIT) {
            Serial.println(" aller ou goto ok ");
            Serial.print(puce_derniere_lue);
            Serial.print(" ");
            Serial.print(puce_a_trouver);
            Serial.print(" ");
            Serial.println(sens);
          }
          MonitMsg("GOTO/OK" , puce_derniere_lue);
          delay(20);
          MonitMsg("EN", (int) ((uint32_t)millis() - temps_au_premier_depart_absolu_ms) );
          temps_tot_puce = 0;
          temps_fin_pause_absolu_ms = 0;
          temps_au_premier_depart_absolu_ms = 0;
          temps_au_depart_absolu_ms = 0;
          no_puce_actuelle = puce_a_trouver;
          commande = 0;
        }
      }
      if (commande == 3 && ((uint32_t)millis() - temps_au_depart_absolu_ms > 2000) ) {    // recalcule de la vitesse apres 2s
        if (puce_derniere_lue != no_puce_actuelle ) {
          if (sens >= 0) {
            if (vitesse_actuelle > 450) vitesse_temp = CalculVitesse(1);
            else if (vitesse_actuelle < 300 ) vitesse_temp = CalculVitesse(5);
            else vitesse_temp = CalculVitesse(3);
            Vitesse_moteur(vitesse_temp, 0);
          } else {
            if (vitesse_actuelle > 450) vitesse_temp = CalculVitesse(2);
            else if (vitesse_actuelle < 300 ) vitesse_temp = CalculVitesse(6);
            else vitesse_temp = CalculVitesse(4);
            Vitesse_moteur(vitesse_temp, -1);
          }
          MonitMsg("GOTO/RECALCULE", vitesse_temp);
          no_puce_actuelle = puce_derniere_lue;
        }
      }
    }
  }
  delay(20);
}
